VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "File2File"
   ClientHeight    =   7455
   ClientLeft      =   60
   ClientTop       =   630
   ClientWidth     =   6615
   LinkTopic       =   "Form1"
   ScaleHeight     =   7455
   ScaleWidth      =   6615
   StartUpPosition =   2  'CenterScreen
   Begin VB.CheckBox chkScrollMatch 
      Caption         =   "Match Scrolling"
      Height          =   375
      Left            =   4920
      TabIndex        =   17
      Top             =   6960
      Value           =   1  'Checked
      Width           =   1455
   End
   Begin VB.CommandButton cmdRestoreFile 
      Caption         =   "Restore File 2"
      Enabled         =   0   'False
      Height          =   375
      Left            =   3480
      TabIndex        =   12
      Top             =   6960
      Width           =   1335
   End
   Begin VB.CommandButton cmdBackupFile 
      Caption         =   "Backup File 2"
      Height          =   375
      Left            =   1800
      TabIndex        =   11
      Top             =   6960
      Width           =   1335
   End
   Begin VB.CommandButton cmdCopyData 
      Caption         =   "Copy Data"
      Height          =   375
      Left            =   2640
      TabIndex        =   8
      Top             =   6240
      Width           =   1335
   End
   Begin VB.TextBox txtEndAddress 
      Height          =   375
      Left            =   3480
      TabIndex        =   7
      Top             =   5280
      Width           =   3015
   End
   Begin VB.TextBox txtStartAddress 
      Height          =   375
      Left            =   120
      TabIndex        =   6
      Top             =   5280
      Width           =   3015
   End
   Begin VB.FileListBox File2 
      Height          =   2820
      Left            =   3480
      TabIndex        =   5
      Top             =   2160
      Width           =   3015
   End
   Begin VB.FileListBox File1 
      Height          =   2820
      Left            =   120
      TabIndex        =   4
      Top             =   2160
      Width           =   3015
   End
   Begin VB.DirListBox Dir2 
      Height          =   1440
      Left            =   3480
      TabIndex        =   3
      Top             =   720
      Width           =   3015
   End
   Begin VB.DirListBox Dir1 
      Height          =   1440
      Left            =   120
      TabIndex        =   2
      Top             =   720
      Width           =   3015
   End
   Begin VB.DriveListBox Drive2 
      Height          =   315
      Left            =   3480
      TabIndex        =   1
      Top             =   360
      Width           =   3015
   End
   Begin VB.DriveListBox Drive1 
      Height          =   315
      Left            =   120
      TabIndex        =   0
      Top             =   360
      Width           =   3015
   End
   Begin VB.CheckBox chkMatchPath 
      Caption         =   "Make Paths Match"
      Height          =   375
      Left            =   120
      TabIndex        =   15
      Top             =   6960
      Value           =   1  'Checked
      Width           =   1695
   End
   Begin VB.Label Label5 
      Caption         =   "Copy From:"
      Height          =   255
      Left            =   120
      TabIndex        =   22
      Top             =   120
      Width           =   1095
   End
   Begin VB.Label Label4 
      Caption         =   "Copy To:"
      Height          =   255
      Left            =   3480
      TabIndex        =   21
      Top             =   120
      Width           =   975
   End
   Begin VB.Label Label3 
      Caption         =   "File Size:"
      Height          =   255
      Left            =   120
      TabIndex        =   20
      Top             =   5760
      Width           =   735
   End
   Begin VB.Label Label2 
      Caption         =   "End Address:"
      Height          =   255
      Left            =   3480
      TabIndex        =   19
      Top             =   5040
      Width           =   975
   End
   Begin VB.Label Label1 
      Caption         =   "Start Address:"
      Height          =   255
      Left            =   120
      TabIndex        =   18
      Top             =   5040
      Width           =   1095
   End
   Begin VB.Label lblStatus 
      Alignment       =   2  'Center
      Caption         =   "Waiting"
      Height          =   255
      Left            =   2760
      TabIndex        =   16
      Top             =   5760
      Width           =   1095
   End
   Begin VB.Label lblFile2 
      Alignment       =   1  'Right Justify
      Height          =   615
      Left            =   4080
      TabIndex        =   14
      Top             =   6240
      Width           =   2415
   End
   Begin VB.Label lblFile1 
      Alignment       =   1  'Right Justify
      Height          =   615
      Left            =   120
      TabIndex        =   13
      Top             =   6240
      Width           =   2415
   End
   Begin VB.Label lblLOF2 
      Height          =   255
      Left            =   4440
      TabIndex        =   10
      Top             =   5760
      Width           =   1095
   End
   Begin VB.Label lblLOF1 
      Height          =   255
      Left            =   1080
      TabIndex        =   9
      Top             =   5760
      Width           =   1095
   End
   Begin VB.Menu mnuOptions 
      Caption         =   "Options"
      Begin VB.Menu mnuUseHex 
         Caption         =   "Use Hex Addresses"
      End
      Begin VB.Menu mnuStartAtZero 
         Caption         =   "First Address in File is 0"
      End
   End
   Begin VB.Menu mnuHelp 
      Caption         =   "Help"
      Begin VB.Menu mnuInstructions 
         Caption         =   "Instructions"
      End
      Begin VB.Menu mnuFormulas 
         Caption         =   "Conversion Formulas"
      End
      Begin VB.Menu mnuAbout 
         Caption         =   "About"
      End
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private SubDir As String

Private BackupFile As String

'Used to test for a failed restore on exit.
Private RestoreError As Boolean

Private Sub chkMatchPath_Click()

If chkMatchPath.Value = 1 Then
chkScrollMatch.Enabled = True
Else
chkScrollMatch.Enabled = False
End If

End Sub

Private Sub cmdBackupFile_Click()

On Error GoTo Errors

If File2.ListIndex <> -1 Then
BackupFile = File2.Path & "\" & File2.FileName

FileCopy BackupFile, SubDir & "BackupFile"

cmdRestoreFile.Enabled = True
End If

Exit Sub

Errors:
MsgBox "Failed to backup the file.  The file is probably being edited with another program.", vbOKOnly, "Backup Failed"

End Sub

Private Sub cmdCopyData_Click()

If Not mnuStartAtZero.Checked Then
If txtStartAddress <> "" Then
If Val(txtStartAddress) = 0 Then
MsgBox "The """ & mnuStartAtZero.Caption & """ option isn't enabled, so the first address in a file is 1, not 0.", vbOKOnly, "Start Address Too Low"
Exit Sub
End If
End If
End If

If File1.ListIndex <> -1 Then
If File2.ListIndex <> -1 Then

lblStatus.Caption = "Working"

Me.Refresh

'Do everything at once
CopyData

lblStatus.Caption = "Done"

End If
End If

End Sub

Private Sub CopyData()

'Uses UGE addresses.

On Error GoTo Errors

'Dim TempChar As String * 1
Dim DataArray() As Byte

Dim Address1 As Double
Dim Address2 As Double
Dim I As Long

'Convert address now
If mnuUseHex.Checked Then
Address1 = Val("&H" & txtStartAddress)
Address2 = Val("&H" & txtEndAddress)
Else
Address1 = Val(txtStartAddress)
Address2 = Val(txtEndAddress)
End If


If mnuStartAtZero.Checked Then
'Adds 1 to the UGE address to make it compatible with
'the internal structure.
Address1 = Address1 + 1
Address2 = Address2 + 1
End If

'Check for File 1 discrepencies
Open File1.Path & "\" & File1.FileName For Binary As #1
If Address1 > LOF(1) Then
Close #1
MsgBox "The Start Address is greater than the size of File 1", vbOKOnly, "Start Address Too High"
Exit Sub
End If

If Address2 > LOF(1) Then
Close #1
MsgBox "The End Address is greater than the size of File 1", vbOKOnly, "Start Address Too High"
Exit Sub
End If
Close #1

'Check for File 2 discrepencies
Open File2.Path & "\" & File2.FileName For Binary As #1
If Address1 > LOF(1) Then
Close #1
MsgBox "Little child, please stop messing with this program. It's too dangerous for you.", vbOKOnly, "Start Address Too High"
Exit Sub
End If

If Address2 > LOF(1) Then
Close #1
MsgBox "You're attempting to copy more data to this file than it originally had. This is bad for all types of Binary files, so you're not allowed.", vbOKOnly, "End Address Too High"
Exit Sub
End If
Close #1

Open File1.Path & "\" & File1.FileName For Binary As #1
Open File2.Path & "\" & File2.FileName For Binary As #2

ReDim DataArray(Address1 To Address2) As Byte

Get #1, Address1, DataArray
Put #2, Address1, DataArray

'For I = Address1 To Address2
'
'Get #1, I, TempChar
'Put #2, I, TempChar
'
'Next I

Close #2
Close #1

Exit Sub

Errors:
Close

MsgBox "Failed to copy the data.  The file is probably being edited with another program.", vbOKOnly, "Copy Data Failed"

End Sub

Private Sub cmdRestoreFile_Click()

On Error GoTo Errors

lblStatus.Caption = "Working"
FileCopy SubDir & "BackupFile", BackupFile
lblStatus.Caption = "Done"

Exit Sub

Errors:
lblStatus.Caption = "Failed"

MsgBox "Failed to restore the file. The file is probably being edited with another program.", vbOKOnly, "Restore Failed"

RestoreError = True

End Sub

Private Sub Dir1_Change()

File1.Path = Dir1.Path

If chkMatchPath.Value = 1 Then
Dir2.Path = Dir1.Path
File2.Path = File1.Path
End If

End Sub

Private Sub Dir1_Scroll()

If chkScrollMatch.Value = 1 Then
If chkMatchPath.Value = 1 Then
Dir2.TopIndex = Dir1.TopIndex
End If
End If

End Sub

Private Sub Dir2_Change()

File2.Path = Dir2.Path

End Sub

Private Sub Drive1_Change()

Dir1.Path = Drive1.Drive

If chkMatchPath.Value = 1 Then
Drive2.Drive = Drive1.Drive
Dir2.Path = Dir1.Path
End If

End Sub

Private Sub Drive2_Change()

Dir2.Path = Drive2.Drive

End Sub

Private Sub File1_Click()

Open File1.Path & "\" & File1.FileName For Binary As #1

If mnuUseHex.Checked Then
lblLOF1 = Hex$(LOF(1) - IIf(mnuStartAtZero.Checked, 1, 0))
Else
lblLOF1 = LOF(1) - IIf(mnuStartAtZero.Checked, 1, 0)
End If
Close #1

lblFile1 = File1.List(File1.ListIndex)

End Sub

Private Sub File1_Scroll()

If chkScrollMatch.Value = 1 Then
If chkMatchPath.Value = 1 Then
File2.TopIndex = File1.TopIndex
End If
End If

End Sub

Private Sub File2_Click()

Open File2.Path & "\" & File2.FileName For Binary As #1

If mnuUseHex.Checked Then
lblLOF2 = Hex$(LOF(1) - IIf(mnuStartAtZero.Checked, 1, 0))
Else
lblLOF2 = LOF(1) - IIf(mnuStartAtZero.Checked, 1, 0)
End If
Close #1

lblFile2 = File2.List(File2.ListIndex)

End Sub

Private Sub Form_Load()

'Dim Path1 As String
'
''A quick disable/enable type of coding
'If True = True Then
'Path1 = "C:\Emulate\nes\"
'
'Drive1.Drive = Path1
'Dir1.Path = Path1
'Drive2.Drive = Path1
'Dir2.Path = Path1
'End If

SubDir = App.Path & "\"

'Restores the user's preference.
mnuUseHex.Checked = GetSetting("File2File", "Settings", "UseHex", True)
mnuStartAtZero.Checked = GetSetting("File2File", "Settings", "StartAtZero", True)

End Sub

Private Sub Form_Unload(Cancel As Integer)

Dim Response As VbMsgBoxResult

Do

'Init the value
RestoreError = False

If cmdRestoreFile.Enabled = True Then
Response = MsgBox("There is an existing backup of " & vbNewLine & """" & BackupFile & """" & vbNewLine & vbNewLine & "Would you like to restore the backup of this file before exiting?" & vbNewLine & vbNewLine & "Press cancel to avoid exiting the program.", vbYesNoCancel, "Restore existing backup?")

If Response = vbYes Then
cmdRestoreFile_Click
ElseIf Response = vbCancel Then
Cancel = 1
Exit Sub
End If
End If

If Not RestoreError Then
Exit Do
End If

Loop

End

End Sub

Private Sub mnuAbout_Click()

Form2.Caption = "About"

Form2.HelpMessage = "This program is designed to aid in using save-states from emulators to easily load changes into the game's memory, and find memory addresses responsible for changes." & vbNewLine & vbNewLine & _
"This version of the program was created by me, ugetab"

Form2.Show

End Sub

Private Sub mnuFormulas_Click()

Dim AddNumber As Byte
Dim ChangeToHex As String

If Not mnuStartAtZero.Checked Then
AddNumber = 1
End If

If Not mnuUseHex.Checked Then
ChangeToHex = "Convert the result to Hex." & vbNewLine
End If

Form2.Caption = "Conversion Formulas"

Form2.HelpMessage = "I've discovered formulas for converting certain Save-State addresses into Memory Modifying codes. These will appear differently depending on what settings you have selected." & vbNewLine & vbNewLine & _
"SNES: ZSNES *.ZS? Files" & vbNewLine & _
"For 7E0000 to 7FFFFF PAR codes(Address needs to be greater than or equal to " & IIf(mnuUseHex.Checked, Hex$(3091 + AddNumber), 3091 + AddNumber) & " and less than or equal to " & IIf(mnuUseHex.Checked, Hex$(134162 + AddNumber), 134162 + AddNumber) & "):" & vbNewLine & _
"((Address) - " & IIf(mnuUseHex.Checked, Hex$(3091 + AddNumber), 3091 + AddNumber) & ")+" & IIf(mnuUseHex.Checked, Hex$(8257536), 8257536) & "=" & vbNewLine & ChangeToHex & vbNewLine & _
"For 400000 to 407FFF PAR codes(Address needs to be greater than or equal to " & IIf(mnuUseHex.Checked, Hex$(269620 + AddNumber), 269620 + AddNumber) & " and less than or equal to " & IIf(mnuUseHex.Checked, Hex$(302387 + AddNumber), 302387 + AddNumber) & "):" & vbNewLine & _
"((Address) - " & IIf(mnuUseHex.Checked, Hex$(269620 + AddNumber), 269620 + AddNumber) & ")+" & IIf(mnuUseHex.Checked, Hex$(4194304), 4194304) & "=" & vbNewLine & ChangeToHex & vbNewLine & _
"For 303000 to 3037FF PAR codes(Address needs to be greater than or equal to " & IIf(mnuUseHex.Checked, Hex$(267571 + AddNumber), 267571 + AddNumber) & " and less than or equal to " & IIf(mnuUseHex.Checked, Hex$(269618 + AddNumber), 269618 + AddNumber) & "):" & vbNewLine & _
"((Address) - " & IIf(mnuUseHex.Checked, Hex$(267571 + AddNumber), 267571 + AddNumber) & ")+" & IIf(mnuUseHex.Checked, Hex$(3158016), 3158016) & "=" & vbNewLine & ChangeToHex & vbNewLine & _
"Genesis: Fusion *.GS? Files" & vbNewLine & _
"For FF0000 to FFFFFF PAR codes(Address needs to be greater than or equal to " & IIf(mnuUseHex.Checked, Hex$(9336 + AddNumber), 9336 + AddNumber) & " and less than or equal to " & IIf(mnuUseHex.Checked, Hex$(74871 + AddNumber), 74871 + AddNumber) & "):" & vbNewLine & _
"((Address) - " & IIf(mnuUseHex.Checked, Hex$(9336 + AddNumber), 9336 + AddNumber) & ")+" & IIf(mnuUseHex.Checked, Hex$(16711680), 16711680) & "=" & vbNewLine & ChangeToHex & vbNewLine

Form2.Show

End Sub

Private Sub mnuInstructions_Click()

Form2.Caption = "Instructions"

Form2.HelpMessage = _
"Before you begin, you should know that this program will simply corrupt a compressed save-state, and won't be helpful even if it works, because the compression virtually randomizes the addresses and data from a human perspective." & vbNewLine & vbNewLine & _
"This method is mostly effective for finding effects that exist in one save-state, and don't exist in another save-state. By this, I imply that you should make a save-state before the effect you want to find exists, and one after the effect you want to find exists. The fewer things that change between save-states when activating the effect you want, the better. This includes being able to make yourself die with a code, so you can prevent yourself from dying by modifying the code." & vbNewLine & vbNewLine & _
"Even if you can't use the resulting addresses you find to directly make a PAR code, you can figure out what to search for within the emulator's search function. One example would be having a value that changes from " & IIf(mnuUseHex.Checked, Hex$(45), 45) & " to " & IIf(mnuUseHex.Checked, Hex$(173), 173) & " to activate the effect you want." & vbNewLine & vbNewLine & _
"Choose a 'Copy From' and 'Copy To' file. Normally, these will be different Save-States from the same exact game...but if you think of a use that doesn't involve such similar files, feel free to try it on files you have manually backed up." & vbNewLine & vbNewLine & _
"Once you have your files chosen, you should be sure the File Sizes match for both save-states." & vbNewLine & _
"At this point, you should press the 'Backup File 2' button. This is helpful because it allows you to more quickly narrow down an address you're looking for(or multiple addresses), and ensures your backup file's original state can be viewed, in case you forget which condition the second save-state was in." & vbNewLine & vbNewLine & _
"You're now ready to begin using a binary search or an intuitive search. A binary search is where you copy from the middle of the file, either to the start or the end of the file. An intuitive search would be where you guess that since a certain amount of related data was in a certain area, you'll start in that range, rather than the middle of the file, and use a binary deduction from there." & vbNewLine & vbNewLine & _
"Copy the portion of data you want to test for an effect, and load the save-state that was represented by the 'Copy To' file. If the effect was activated, then cut the amount of data you're copying down to half, such as having a pair of copy addresses that use " & IIf(mnuUseHex.Checked, Hex$(3091), 3091) & " and " & IIf(mnuUseHex.Checked, Hex$(5000), 5000) & ", and making the end or start be around " & IIf(mnuUseHex.Checked, Hex$(4000), 4000) & ", or even " & IIf(mnuUseHex.Checked, Hex$(3500), 3500) & " when you do your next test. This is what I mean by a binary search. You cut the data in half, and If Effect Wanted = true, continue using that range for testing. If the effect wasn't activated, use a different range, which can be a portion of the larger data area that confirmed that the effect was within a certain range of bytes. How much or little you copy depends on user preference and experience." & vbNewLine & vbNewLine & _
"As you gradually narrow down the addresses, you could narrow it down to a single address, or you may notice that there's a lowest address and a highest address that both of them must be at for the effect to be activated. This usually means that more than 1 value is involved in activating the effect, or perhaps the effect is simply invisible, because one value deals with the on-screen cue that normally informs you of what you're looking for." & vbNewLine & vbNewLine & _
"I have a FAQ on this subject, and I have included it with this program. If you feel this method is desirable enough to spend time learning about it from reading, you should read it."

Form2.Show

End Sub

Private Sub mnuStartAtZero_Click()

mnuStartAtZero.Checked = Not mnuStartAtZero.Checked

'Saves the user's preference.
SaveSetting "File2File", "Settings", "StartAtZero", mnuStartAtZero.Checked

If File1.ListIndex <> -1 Then
File1_Click
End If

If File2.ListIndex <> -1 Then
File2_Click
End If

End Sub

Private Sub mnuUseHex_Click()

mnuUseHex.Checked = Not mnuUseHex.Checked

'Saves the user's preference.
SaveSetting "File2File", "Settings", "UseHex", mnuUseHex.Checked

If File1.ListIndex <> -1 Then
File1_Click
End If

If File2.ListIndex <> -1 Then
File2_Click
End If

End Sub

Private Sub txtEndAddress_Change()

If Val(txtEndAddress) < 0 Then
txtEndAddress = 0
End If

End Sub

Private Sub txtStartAddress_Change()

If Val(txtStartAddress) < 0 Then
txtStartAddress = 0
End If

End Sub
